<template>
  <div class="px-2">
    <h2 class="text-center grey--text my-5">DASHBOARD</h2>
    <v-row class="justify-center">
      <v-col
        cols="12"
        sm="6"
        md="4"
      >
        <v-card class="mx-4 my-2" color="primary" dark>
          <div class="d-flex flex-no-wrap justify-space-between">
            <div>
              <v-card-title
                class=""
              >
                EMPLOYEES
              </v-card-title>
              <v-card-subtitle class="mt-5 headline">{{employeesize}}</v-card-subtitle>
            </div>
            <v-avatar
              class="ma-2"
              size="50"
              tile
            >
              <v-icon>mdi-account</v-icon>
            </v-avatar>
          </div>
        </v-card>
      </v-col>
      <v-col
        cols="12"
        sm="6"
        md="4"
      >
        <v-card class="mx-4 my-2" color="primary" dark>
          <div class="d-flex flex-no-wrap justify-space-between">
            <div>
              <v-card-title
                class=""
              >DEPARTMENTS
              </v-card-title>
              <v-card-subtitle class="mt-5 headline">{{departmentsize}}</v-card-subtitle>
            </div>
            <v-avatar
              class="ma-2"
              size="50"
              tile
            >
              <v-icon>mdi-home</v-icon>
            </v-avatar>
          </div>
          </v-card>
      </v-col>
      <v-col
        cols="12"
        sm="6"
        md="4"
      >
        <v-card class="mx-4 my-2" color="primary" dark>
          <div class="d-flex flex-no-wrap justify-space-between">
            <div>
              <v-card-title
                class=""
              >LEAVE TYPE
              </v-card-title>
              <v-card-subtitle class="mt-5 headline">{{leavetypesize}}</v-card-subtitle>
            </div>
            <v-avatar
              class="ma-2"
              size="50"
              tile
            >
              <v-icon>mdi-clipboard-text</v-icon>
            </v-avatar>
          </div>
        </v-card>
      </v-col>
    </v-row>
    <v-data-table
      :headers="headers"
      :items="leave"
      :search="search"
      class="elevation-1"
    >
      <template v-slot:top>
        <v-toolbar flat color="primary" class="">
          <v-toolbar-title class="white--text">List of Leave Application</v-toolbar-title>
          <v-divider
            class="mx-4 white"
            inset
            vertical
          ></v-divider>
          <v-spacer></v-spacer>
          <v-text-field
            v-model="search"
            append-icon="mdi-magnify"
            label="Search"
            solo
            single-line
            hide-details
          ></v-text-field>
        </v-toolbar>
      </template>
      <template v-slot:[`item.status`]="{ item }">
        <v-chip :color="getColor(item.status)" class="black--text">{{ item.status }}</v-chip>
      </template>
      <template   v-slot:[`item.actions`]="{ item }">
        <v-btn
          class="secoundary white--text"
          :to="{ name: 'LeaveView', params: { id: `${item.id}`, uid: `${item.uid}` }}"
        >
          View
        </v-btn>
      </template>
    </v-data-table>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';
// eslint-disable-next-line import/no-cycle
import { getDepartment, getLeaveType, getUserSize } from '@/firebase/db';
import { getAuthenticatedUser } from '@/fb';
import Employee from '@/models/Employee';
import EmployeeList from '@/models/EmployeeList';
import ApplyLeave from '@/models/ApplyLeave';
import ApplyLeaveList from '@/models/ApplyLeaveList';

export default {
  name: 'Home',
  components: {
  },
  data() {
    return {
      departmentsize: '',
      leavetypesize: '',
      employeesize: '',
      search: '',
      employee: [],
      headers: [
        {
          text: 'Name',
          align: 'start',
          value: 'name',
        },
        { text: 'Leave Type', value: 'leavetype' },
        { text: 'Posted Date', value: 'dateCreated' },
        { text: 'Status', value: 'status' },
        { text: 'Actions', value: 'actions', sortable: false },
      ],
      leave: [],
      leave2: new Map(),
    };
  },
  computed: {
    ...mapGetters({
      user: 'getUser',
    }),
  },
  created() {
    getDepartment().then((value) => {
      this.departmentsize = value;
    });
    getLeaveType().then((value) => {
      this.leavetypesize = value;
    });
    getUserSize().then((value) => {
      this.employeesize = value;
    });
  },
  mounted() {
    getAuthenticatedUser().then((user) => {
      console.log('hello this is user', user);
      this.employeeDetails = new EmployeeList(
        { uid: user.uid, className: Employee.getClassName() },
      );
      console.log('this function work');
      this.employeeDetails.fetch2({ orderBy: 'dateCreated', paginate: true })
        .then((page) => {
          this.employee = page;
          console.log('this is final list you are seeing right now  !!!!!!!!!!!!!!!', this.employee);
          this.employee.forEach((data) => {
            console.log('each data ', data.id);
            this.leaveDetails = new ApplyLeaveList(
              { uid: data.id, className: ApplyLeave.getClassName() },
            );
            this.leaveDetails.fetch2({ orderBy: 'dateCreated', paginate: true })
              .then((value) => {
                this.leave.push(...value);
              });
          });
        });
    });
  },
  methods: {
    action(value) {
      console.log(value);
      this.$router.push({ name: 'LeaveView' });
      this.$emit('action', value);
    },
    getColor(status) {
      if (status === 'Awaiting Approval') {
        return 'info';
      } if (status === 'Approved') {
        return 'success';
      }
      return 'error';
    },
  },
};
</script>
